/*~FILE: appl_hdr.h
  (C) Copyright 1999 by SIGNALWARE Corporation.

  Property of: SIGNALWARE Corporation (sm)
               P.O. Box 50225
               Colorado Springs, CO 80949

  ~PRODUCT: AED-xxx - Analog Expansion Daughterboard
  ~VERSION: 3.0

  4/16/99 V1.0 - initial version
  5/20/99 V1.1 - update current type & add appl_end
  5/25/98 V1.2 - add VoltageCurrentPos
  5/27/98 V1.3 - add mailbox support & _appl_hdr
  6/6/99  V1.4 - disable mailbox support and define LED colors.
  6/10/99 V1.5 - add trans out prototype
  7/28/99 V2.0 - add appl_prm, remove constants and types
  9/15/99 V2.1 - add DSP register addresses
  11/5/99 V3.0 - add buf_number parm and idle return code
  ~!

  ~HEADER:
     Standard headers for all AED applications employing expansion
   memory interface for access to the daughter board.
  ~!
  ~WARNING:
    This code may be modified only as indicated to implement various
    applications. If this code is changed to implement an application,
    do not change the name of the module. This name is used in AED_main
    to get the buffer type details, number of records and number of
    blocks.
   ~! */
/**********************************************************************/
#ifndef _appl_hdr_
#define _appl_hdr_

/* #define MAIL_SIZE   8   */   /* application may have a different length
                            mail queue; restrictions: must be a power
                            of 2 if desired (including 1) and must
                            be not defined if not desired.         */
#define RED_LED 0
#define GREEN_LED 1
#define DSP_CNTL_ADDR(MAP)     0x1780000
#define DSP_STAT_ADDR(MAP)     0x1780004
#define DSP_DIPOPT_ADDR(MAP)   0x1780008
#define DSP_DIPBOOT_ADDR(MAP)  0x178000C
#define DSP_DSPOPT_ADDR(MAP)   0x1780010
#define DSP_DSPBOOT_ADDR(MAP)  0x1780014
#define DSP_FIFOSTAT_ADDR(MAP) 0x1780018
#define DSP_SDCNTL_ADDR(MAP)   0x178001C
#define DMA_FS_MODE  2
#define DMA_WS_MODE  1
#define DMA_RS_MODE  0
/*---------------------------------------------*/
/* the following code is application dependent */
/* end of application dependent code */
/*---------------------------------------------*/
/* standard block type definition */
typedef union {
  int * word;
  unsigned int * uword;
  short * hword;
  unsigned short * uhword;
  char * byte;
  unsigned char * ubyte;
} ApplBlockType;

/* mailbox variables if desired */
#ifdef MAIL_SIZE
extern unsigned int MailboxContent[MAIL_SIZE];
extern unsigned int MailboxCountIn;
#endif

/* standard application interface functions */
void appl_parms(unsigned int *blocks, unsigned int *records,
                unsigned int *reclen, unsigned int *size,
                unsigned int *mode);
void appl_init(ApplBlockType data_buffer);
int  appl_process(ApplBlockType data_block, int buf_number);
int  appl_idle(void);
void appl_end(void);

/* interrupt routine for transfer to PC */
extern void interrupt trans_out_interrupt(void);
#endif
