/*~FILE: dma_ex.h
  (C) Copyright 1999 by SIGNALWARE Corporation.

  Property of: SIGNALWARE Corporation (sm)
               P.O. Box 50225
               Colorado Springs, CO 80949

  ~PRODUCT: AED-xxx - Analog Expansion Daughterboard
  ~VERSION: 3.0

  4/13/99 V1.0 - initial version
  7/28/99 V2.0 - add size parm to program DMA
  9/15/99 V3.0 - add DMAC parm to program DMA

  ~!

  ~HEADER:
     Standard headers for DMA functions employing expansion
   memory interface for access to the daughter board.
  ~!
  ~WARNING:
    This code should not generally be modified for any application.
    If this code is changed other than to correct an error, please
    change the name of the module to avoid confusion.
   ~! */
/**********************************************************************/
#define DMAC_EN_LOW        0 /* DMAC pin is held low */
#define DMAC_EN_HIGH       1 /* DMAC pin is held high */
#define DMAC_EN_RSYNC_STAT 2 /* DMAC reflects RSYNC STAT */
#define DMAC_EN_WSYNC_STAT 3 /* DMAC reflects WSYNC STAT */
#define DMAC_EN_FRAME_COND 4 /* DMAC reflects FRAME COND */
#define DMAC_EN_BLOCK_COND 5 /* DMAC reflects BLOCK COND */
/**********************************************************************/

void test_DMA_channel(void *src);
void program_DMA_channel(void *dest, int count, int nbuf,
               unsigned int size, unsigned int dmac_en);
void start_DMA_channel(unsigned short chan);

